# 12.5 Summary

In this chapter, we discussed how to deploy and maintain our Go web applications. We also looked at some closely related topics which can help us to keep them running smoothly, with minimal maintenance. 

Specifically, we looked at: 

- Creating a robust logging system capable of recording errors, and notifying system administrators
- Handling runtime errors that may occur, including logging them, and how to relay this information in a user-friendly manner that there is a problem
- Handling 404 errors and notifying users that the requested page cannot be found
- Deploying applications to a production environment (including how to deploy updates)
- How to deploy highly available applications
- Backing up and restoring files and databases

After reading the contents of this chapter, those thinking about developing a web application from scratch should already have the full picture on how to do so; this chapter provided an introduction on how to manage deployment environments, while previous chapters have focused on the development of code.

## Links

- [Directory](preface.md)
- Previous section: [Backup and recovery](12.4.md)
- Next chapter: [Building a web framework](13.0.md)
