* [Go Environment Configuration](01.0.md)
	* [Installation](01.1.md)
	* [$GOPATH and workspace](01.2.md)
	* [Go commands](01.3.md)
	* [Go development tools](01.4.md)
	* [Summary](01.5.md)
* [Go basic knowledge](02.0.md)
	* [Hello, Go](02.1.md)
	* [Go foundation](02.2.md)
	* [Control statements and functions](02.3.md)
	* [struct](02.4.md)
	* [Object-oriented](02.5.md)
	* [interface](02.6.md)
	* [Concurrency](02.7.md)
	* [Summary](02.8.md)
* [Web foundation](03.0.md)
	* [Web working principles](03.1.md)
	* [Build a simple web server](03.2.md)
	* [How Go works with web](03.3.md)
	* [Get into http package](03.4.md)
	* [Summary](03.5.md)
* [HTTP Form](04.0.md)
	* [Process form inputs](04.1.md)
	* [Validation of inputs](04.2.md)
	* [Cross site scripting](04.3.md)
	* [Duplicate submissions](04.4.md)
	* [File upload](04.5.md)
	* [Summary](04.6.md)
* [Database](05.0.md)
	* [database/sql interface](05.1.md)
	* [How to use MySQL](05.2.md)
	* [How to use SQLite](05.3.md)
	* [How to use PostgreSQL](05.4.md)
	* [How to use beedb ORM](05.5.md)
	* [NOSQL](05.6.md)
	* [Summary](05.7.md)
* [Data storage and session](06.0.md)
	* [Session and cookies](06.1.md)
	* [How to use session in Go](06.2.md)
	* [Session storage](06.3.md)
	* [Prevent hijack of session](06.4.md)
	* [Summary](06.5.md)
* [Text files](07.0.md)
	* [XML](07.1.md)
	* [JSON](07.2.md)
	* [Regexp](07.3.md)
	* [Templates](07.4.md)
	* [Files](07.5.md)
	* [Strings](07.6.md)
	* [Summary](07.7.md)
* [Web services](08.0.md)
	* [Sockets](08.1.md)
	* [WebSocket](08.2.md)
	* [REST](08.3.md)
	* [RPC](08.4.md)
	* [Summary](08.5.md)
* [Security and encryption](09.0.md)
	* [CSRF attacks](09.1.md)
	* [Filter inputs](09.2.md)
	* [XSS attacks](09.3.md)
	* [SQL injection](09.4.md)
	* [Password storage](09.5.md)
	* [Encrypt and decrypt data](09.6.md)
	* [Summary](09.7.md)
* [Internationalization and localization](10.0.md)
	* [Time zone](10.1.md)
	* [Localized resources](10.2.md)
	* [International sites](10.3.md)
	* [Summary](10.4.md)
* [Error handling, debugging and testing](11.0.md)
	* [Error handling](11.1.md)
	* [Debugging by using GDB](11.2.md)
	* [Write test cases](11.3.md)
	* [Summary](11.4.md)
* [Deployment and maintenance](12.0.md)
	* [Logs](12.1.md)
	* [Errors and crashes](12.2.md)
	* [Deployment](12.3.md)
	* [Backup and recovery](12.4.md)
	* [Summary](12.5.md)
* [Build a web framework](13.0.md)
	* [Project program](13.1.md)
	* [Customized routers](13.2.md)
	* [Design controllers](13.3.md)
	* [Logs and configurations](13.4.md)
	* [Add, delete and update blogs](13.5.md)
	* [Summary](13.6.md)
* [Develop web framework](14.0.md)
	* [Static files](14.1.md)
	* [Session](14.2.md)
	* [Form](14.3.md)
	* [User validation](14.4.md)
	* [Multi-language support](14.5.md)
	* [pprof](14.6.md)
	* [Summary](14.7.md)
* [References](ref.md)
* [preface](preface.md)