# 11 エラー処理、デバッグとテスト
大部分のプログラマが"プログラム"を行う時間をbugの検査とbugの修正にかけています。あなたがコードを修正しているかシステムを再構築しているかに関わらず、ほとんどは大量の時間を故障の排除とテストに費やしています。外の世界は我々プログラマをデザイナだと思い込んでいます。システムをゼロから作り出すことができ、とても偉大で相当面白みのある仕事だと。しかし実際のところ我々は毎日エラーを取り除き、デバッグし、テストを行うことに終始しています。当然もしあなたに良い習慣があり、技術プランとこのような問題に直面しているとしたら、エラーを排除する時間を最小限に抑えて時間を価値のある事柄に費やそうとするかもしれません。

しかし残念なことに多くのプログラマはエラーの処理、デバッグやテストに時間をかけたいとは思いません。結果、アプリケーションが実運用された後になってエラーを探し出し問題を特定することにより多くの時間を費やすことになります。そのため、我々はアプリケーションを設計する前にエラー処理のプランやテスト等を前もって準備します。将来コードを修正、システムをアップグレードするのが簡単になります。

Webアプリケーションを開発するにあたって、エラーは避けられないものです。ではどのようにしてエラーの原因と問題の解決を探し出せばよいのでしょうか？ 11.1節ではGo言語においてどのようにエラー処理を行い、自分のパッケージを設計して、関数のエラー処理を行うかご紹介します。11.2節ではGDBを使ってどのように我々のプログラムをデバッグするかご紹介します。動的に実行した状況かで各種変数の情報、実行状況の監視とデバッグ。

11.3節ではGo言語のユニットテストに対して深く見ていくことにします。どのようにしてユニットテストを書くのかやGoのユニットテストのルールをどのように定義するのかをご紹介し、今後アップグレードや修正に対応したテストコードが最小化されたテストを実行できるよう保証します。

長きにわたって、良好なデバッグ、テストの習慣を身につけるのは多くのプログラマが逃げてきた事柄です。ですから、もう逃げないでください。あなたの現在のプロジェクトの開発から。Go Web開発を学習することで良好な習慣を身につけてください。

## 目次
 
![](images/navi11.png?raw=true)

## links
   * [目次](<preface.md>)
   * 前へ: [第十章まとめ](<10.4.md>)
   * 次へ: [エラー処理](<11.1.md>)
