# 12.5 まとめ
この章ではどのようにして我々の開発したWebアプリケーションのデプロイとメンテナンスを行うかについていくつかのトピックを討論しました。これらの内容は非常に重要で、メンテナンスを最小化し、アプリケーションの円滑な運用を行うためにはかならずこれらの問題を考慮する必要があります。

この章で討論した内容は具体的には：

- 強靭なログシステムを作成し、問題が発生した際にエラーを記録してシステム管理者に通知を行うことができます。
- 実行時に発生しうるエラーの処理。ログへの記録を含み、システムが発生させた問題についてユーザフレンドリーな表示をどのようにユーザに行うか。
- 404エラーの処理。ユーザがリクエストしたページが見つからないことを示します。
- アプリケーションを生産環境の中にデプロイする。(どのようにしてデプロイを更新するかを含みます)
- デプロイしたアプリケーションの可用性を高めるにはどうすればよいか。
- ファイル及びデータベースのバックアップとリストア

この章を読み終わると、スクラッチで一つのWebアプリケーションを開発するのに対してどのような問題を考慮しなければならないのか、あなたは既に全面的な理解が得られたはずです。この章の内容は実際の環境において前の各章でご紹介した開発コードを管理するのに役立ちます。

## links
   * [目次](<preface.md>)
   * 前へ: [バックアップとリストア](<12.4.md>)
   * 次へ: [どのようにしてWebフレームワークを設計するか](<13.0.md>)
