# 1 Настройка окружения Go

Добро пожаловать в мир Go! Давайте начнем.

Go - это язык программирования, характерными чертами которого являюся быстрое время компиляции, сборка мусора и многопоточность. Вот список преимуществ Go:

- Большие проекты компилируюстя за несколько секунд.
- Модель разработки в Go легко объяснима, Go позволяет избежать большинства проблем, связанных с заголовочными файлами в стиле языка C.
- Это статически типизированный язык программирования, в системе типов которого не поддерживается иерархия уровней, поэтому пользователю не нужно тратить время на выяснение отношений между типами. Go, скорее, "легковесный" объектно-ориентированный язык программирования.
- Go обеспечивает сборку мусора. Он предлагает встроенную поддержку конкарентности и протоколов связи.
- Разработан для многоядерных процессоров.

Go - компилируемый язык. Он сочетает в себе эффективность разработки интерпретируемых или динамически типизированных языков и безопасность статически типизируемых языков. Его задача - стать оптимальным вариантом среди языков программирования для современных многоядерных компьютеров, работающих в сети. Чтобы стать таким языком, нужно решить несколько задач, таких как поддержка богатой, выразительной и легкой системы типизации, поддержка одновременности выполнения процедур "из коробки" и точно регулируемая сборка мусора. Иногда при программировании на каком-либо языке оказывалось так, что пакетов для решения всех этих задач практичным способом просто не было. Это и явилось причиной появления языка Go.

В этой главе я покажу, как установить и настроить среду разработки на Go.

## Ссылки

- [Содержание](preface.md)
- Следующий раздел: [Установка](01.1.md)
