# 1.1 Установка

## 3 способа установить Go

Существует несколько способов установить Go, можете выбирать, какой Вам больше нравится. 3 наиболее распространенных таковы:

- Установка из пакетов.
	- Команда разработчиков Go предлагает установочные пакеты для Windows, Linux, Mac и других операционных систем. Это, вероятно, наиболее легкий путь.
- Установка из исходного кода.
	- Это метод популярен среди разработчиков, которые знакомы с работой в Unix-подобных системах.
- Установка с использованием сторонних инструментов.
	- Существует множество сторонних инструментов и менеджеров пакетов для установки Go, таких как apt-get в Ubuntu и homebrew для Mac.
	
В случае, если Вы собираетесь установить несколько версий Go на одном компьютере, советую Вам ознакомиться с инструментом [GVM](https://github.com/moovweb/gvm). Это лучший инструмент для решения этой задачи, который я когда-либо встречал. Впрочем, решать Вам.

## Установка из исходного кода

Поскольку Go частично написан на Plan 9 C и AT&T assembler, Вам нужно установить компилятор C перед тем, как продолжить.

На Mac у Вас есть компилятор, если на компьютере установлен Xcode.

На Unix-подобных системах Вам нужно установить gcc или подобный ему компилятор. Например, используя пакетный менеджер apt-get, по умолчанию включенный в Ubuntu, можно установить требуемые пакеты следующей командой:

 `sudo apt-get install gcc libc6-dev`

На Windows для установки gcc Вам нужно сначала установить MinGW. Не забудьте настроить переменные окружения после завершения установки. ( ***Все, что выглядит таким образом  - здесь и далее добавлено переводчиком на английский - если Вы используете 64-битную Windows, Вам нужно будет установить 64-битную версию MiniGW*** )

Итак, для того, чтобы скачать исходные коды Go и скомпилировать их, выполните следующие команды ( ***При этом исходники скачаются в тот каталог, в которой Вы находитесь. Для того, чтобы скачать их в другой каталог, сначала перейдите в нее.***):

	git clone https://go.googlesource.com/go
	cd go/src
	./all.bash 
	
В случае успешной установки по ее завершении появится сообщение "ALL TESTS PASSED."

На Windows то же самое можно сделать с помощью запуска файла `all.bat`.

Если Вы используете Windows, установщик настроит переменные окружения автоматически. В Unix-подобных системах Вам нужно будет настроить их самому следующим образом ( ***Если устанавливаемая версия Go больше 1.0, настраивать переменную $GOBIN не надо, она автоматически будет равна $GOROOT/bin, о чем мы поговорим в следующем разделе***):

    export GOROOT=$HOME/go
    export GOBIN=$GOROOT/bin
    export PATH=$PATH:$GOROOT/bin

Если Вы видите следуюую информацию, все настроено правильно:

![](images/1.1.mac.png?raw=true)

Рисунок 1.1 Информация после установки из исходных кодов.

Если Вы видите информацию о том, как пользоваться Go (Usage), это значит, что Вы успешно установили Go. Если же выдается "no such command", проверьте переменную $PATH на предмет содержания в ней пути к каталогу установки Go.

## Установка, используя стандартные установочные пакеты

Для каждой из поддерживаемых операционных систем в Go имеются установочные пакеты, из которых можно легко произвести установку одним щелчком мыши. Они установят Go в каталог `/usr/local/go` (`c:\Go` в Windows) по умлочанию. Конечно, Вы можете изменить путь установки, но в этом случае Вам придется изменить также и значения переменных окружения так, как было показано выше.

### Как проверить, 32-битная или 64-битная у Вас операционная система?

Следующий наш шаг зависит от разрядности Вашей операционной системы, поэтому перед загрузкой пакетов нам надо ее узнать.

Если у Вас Windows, нажмите `Win+R` и запустите командную строку. Выполните команду `systeminfo`, которая выдаст Вам информацию о системе. Найдите строку, содержащую "system type" - если Вы видите "x64-based PC", это означает 64-битную ОС, в другом случае - 32-битную.

Я настоятельно рекомендую использовать 64-битный пакет, если Вы - пользователь Mac, так как Go больше не поддерживает 32-битные процессоры на Mac OSX.

Пользователям Linux можно выполнить команду `uname -a` в терминале для того, чтобы ознакомиться с информацией о системе.
64-битная ОС покажет следующее:

    <...некоторая информация...> x86_64 x86_64 x86_64 GNU/Linux
    // некоторые ОС типа Ubuntu 10.04 покажут следующее:
    x86_64 GNU/Linux

32-битная ОС - следующее:

    <...информация...> i686 i686 i386 GNU/Linux

### Mac

Зайдите на [страницу загрузки](https://golang.org/dl/), выберите `go1.4.2.darwin-386.pkg` для 32-битных систем или `go1.4.2.darwin-amd64.pkg` для 64-битных. Далее жмите все время "next", `~/go/bin` будет добавлен к системной переменной $PATH после того, как установка закончится. Теперь откройте терминал и напечатайте `go`. Вы должны увидеть то же, что показано на рисунке 1.1.

### Linux

Зайдите на [страницу загрузки](https://golang.org/dl/), выберите `go1.4.2.linux-386.tar.gz` для 32-битных систем или `go1.4.2.linux-amd64.tar.gz` для 64-битных. Предположим, Вы хотите установить Go в каталог `$GO_INSTALL_DIR`. Распакуйте `tar.gz` в этот каталог командой `tar zxvf go1.4.2.linux-amd64.tar.gz -C $GO_INSTALL_DIR`. Затем измените прееменную $PATH следующим образом: `export PATH=$PATH:$GO_INSTALL_DIR/go/bin`. Теперь откройте терминал и напечатайте `go`. Вы должны увидеть то же, что показано на рисунке 1.1.

### Windows

Зайдите на [страницу загрузки](https://golang.org/dl/), выберите `go1.4.2.windows-386.msi` для 32-битных систем или `go1.4.2.windows-amd64.msi` для 64-битных. Далее жмите все время "next", `c:/go/bin` будет добавлен к системной переменной $PATH после того, как установка закончится. Теперь откройте терминал и напечатайте `go`. Вы должны увидеть то же, что показано на рисунке 1.1.

## Установка с использованием сторонних инструментов 

### GVM

GVM - это инструмент управления версиями Go, разработанный сторонними разработчиками, наподобие rvm для ruby. Он довольно-таки легок в использовании. Установить gvm можно следующей командой в терминале:

    bash < <(curl -s -S -L https://raw.github.com/moovweb/gvm/master/binscripts/gvm-installer)

Теперь можно устанавливать Go с помощью следующих команд:

    gvm install go1.4.2
    gvm use go1.4.2

На этом процесс установки закончен.

### apt-get

Ubuntu - это наиболее распространенный релиз Linux для рабочих станций. Он использует `apt-get` для управления пакетами. С помощью него мы можем установить Go с помощью следующих команд:

    sudo add-apt-repository ppa:gophers/go
    sudo apt-get update
    sudo apt-get install golang-stable

### Homebrew

Homebrew - это инструмент для управления пакетами, используемый в Mac. Используя его, можно установить Go следующей командой:

    brew install go

## Ссылки

- [Содержание](preface.md)
- Предыдущий раздел: [Настройка окружения Go](01.0.md)
- Следующий раздел: [$GOPATH и рабочий каталог](01.2.md)
