# 1.1 Kurulum

## Go'yu kurmanın üç yolu

Bilgisayarınızda Go geliştirme ortamını yapılandırmanın bir çok youlu var, ve hangisini isterseniz onu seçebilirsiniz. En çok tercih edilen üç yol aşağıdakilerden oluşmaktadır.


-  Resmi kurulum paketleri.
	- Go ekibi Windows, Linux, Mac ve diğer işletim sistemleri için pratik bir kurulum paketi sunuyor. Muhtemelen başlamanın en kolay yolu da bu paket.
- Kaynak kodunu kullanarak kurmak.
    -  Unix benzeri sistemleri kullananlar için popüler bir yöntem.
- Üçüncü parti yazılımları kullanarak.
	- Go'yu kurmak için bir çok üçüncü parti yazılım mevcut, Ubuntu/Debian için apt-get, Mac için homebrew.
	
Eğer birden fazla Go sürümünü kurmak isterseniz, [GVM](https://github.com/moovweb/gvm) aracını kullanabilirsiniz. Birden fazla sürümü kurmanın en iyi yolu bu aracı kullanmak, aksi halde kendiniz uğraşmak zorunda kalacaksınız.

## Kaynak kodu kullanarak

Go'nun bazı bölümleri Plan 9 C ve AT&T derleyicisi kullanarak yazılmıştır, bu yüzden bir sonraki adıma geçmek için bir C derleyicisi kurmanız gerekiyor.

Mac için, daha önce xcode'u kurduysanız zaten derleyiciniz var demektir.

Unix türevi sistemler için, gcc ya da benzer bir derleyici kurmalısınız. Örneğin, apt-get paket yöneticisini kullanarak(Ubuntu/Debian), gerekli derleyici paketlerini kurabilirsiniz:

 `sudo apt-get install gcc libc6-dev`

Windows için , gcc kurmak için önce MinGW'yi kurmanız gerekmektedir. Kurulum bittikten sonra ortam değişkenlerini yapılandırmayı unutmayın.( ***Bu formattaki satırlar çevirmenin yorumlarını içerir: 64-bit Windows kullanıyorsanız,  MinGW'nin 64-bit sürümünü kurmalısınız*** )

Go ekibi kaynak kodlarını yönetmek için [Mercurial](http://mercurial.selenic.com/downloads/) kullanıyor, Go'nun kaynak kodlarını alabilmek için sizinde yüklemeniz gerekiyor.

Bu aşamada, aşağıdaki komut Go kaynak kodunu klonlayıp, derleyecektir.( ***Kaynak kodlarını bulunduğunuz dizine klonlayacaktır. Devam etmeden önce çalışma dizininize geçin. Bu işlemin sonuçlanması biraz zaman alabilir.*** )

	hg clone -u release https://code.google.com/p/go
	cd go/src
	./all.bash 
	
"ALL TESTS PASSED." mesajı kurulumun başarılı bir şekilde yapıldığını bildirir.

Windows için , `all.bat` isimli dosyayı çalıştırarak da aynı sonuca ulaşabilirsiniz.

Eğer Windows kullanıyorsanız, kurulum paketi sizin için ortam değişkenlerini otomatik olarak yapılandırcaktır. Unix türevi sistemlerde, aşağıdaki komutları kullanarak ortam değişkenlerini ayarlayabilirsiniz. ( ***Eğer Go sürümünz 1.0dan büyükse GOBIN değişkeni otomatik olarak GOROOT/bin olarak ayarlanacaktır. Sonraki bölümde daha ayrıntılı inceleyeceğiz.***)

    export GOROOT=$HOME/go
    export GOBIN=$GOROOT/bin
    export PATH=$PATH:$GOROOT/bin

Eğer aşağıdaki ekranı görebiliyorsanız, kurulumunuz tamamlanmış demektir.

![](images/1.1.mac.png?raw=true)

Şekil 1.1 Kaynak kod ile Go kurduktan sonraki bilgilendirme ekranı

Ekranda Go bilgilerini görebiliyorsanız, kurulum başarılı olmuş demektir. Eğer "komut bulunamadı" uyarısını alırsanız, $PATH ortam değişkenin Go kurulum dizinini içerip içermediğini kotrol edin.

## Standart kurulum paketlerini kullanarak
Go desteklediği her işletim sistemi için tek tıkla çalışan kurulum paketlerine sunar. Bu paketler Go'yu öntanımlı olarak `/usr/local/go` (`c:\Go`  Windows'da )dizinine kurar. Tabiki bunu değiştirebilirsiniz, ama yukarıda gösterilen bütün ortam değişkenlerinide güncellenmeniz gerekcektir..

### Sisteminizin 32-bit mi yoksa 64-bit mi olduğunu nasıl anlarsınız?

Bir sonraki adım işletim sistemine bağlı, bu yüzden standart kurulum paketlerini indirmeden önce bunu öğrenmeliyiz.

Eğer Windows kullanıyorsanız `Win + r` tuşlarına basın. Açılan pencerede `systeminfo` yazıp enter tuşuna basarsınız size işletim sisteminiz hakkında bilgiler verecektir. "system type" ile başlıyan satırı bulun, eğer "x64-based PC" ifadesini görürseniz, bilgisayarınız 64-bit aksi halde 32-bit'tir.

Ben şiddetle 64-bitlik paketi indirmenizi öneriyorum. Eğer Mac kullanıyorsanız Go artık 32-bitlik işlemciler için destek sunmuyor.

Linux kullanıcılar  `uname -a` ile gerekli bilgiye ulaşabilir.
Eğer bilgisayarınız 64-bit ise aşağıdaki gibi bir ekran görmeniz gerekiyor:

    <diğer bilgiler> x86_64 x86_64 x86_64 GNU/Linux
    // Ubuntu 10.04 türevlerinde aşağıdaki gibide görülebilir
    x86_64 GNU/Linux

32-bit ise:

    <diğer bilgiler> i686 i686 i386 GNU/Linux

### Mac

[İndirme sayfasına](http://code.google.com/p/go/downloads/list) gidin , 32-bit sistemler için `go1.0.3.darwin-386.pkg` ya da 64-bit sistemler için `go1.0.3.darwin-amd64.pkg` seçin. Sayfanın sonuna gidip "next" tıklayın, kurulum bitince  `~/go/bin` $PATH değişkenine otomatik olarak eklenecektir. Bir terminal açıp  `go` yazın ve enter tuşuna basın. Şekil 1.1'dekine benzer bir çıktı almanız gerekiyor.

### Linux

[İndirme sayfasına]((http://code.google.com/p/go/downloads/list) gidin , 32-bit sistemler için `go1.0.3.linux-386.tar.gz` ya da 64-bit sistemler için  `go1.0.3.linux-amd64.tar.gz` seçin. Go'yu `$GO_INSTALL_DIR` altına kurmak istediğinizi varsayalım. `tar zxvf go1.0.3.linux-amd64.tar.gz -C $GO_INSTALL_DIR` komutunu kullanarak arşiv dosyasını istediğiniz dizine açın. $PATH değişkenini ayarlayın: `export PATH=$PATH:$GO_INSTALL_DIR/go/bin`. Bir terminal açıp  `go` yazın ve enter tuşuna basın. Şekil 1.1'dekine benzer bir çıktı almanız gerekiyor.

### Windows

[İndirme sayfasına]((http://code.google.com/p/go/downloads/list) gidin, 32-bit sistemler için `go1.0.3.windows-386.msi` ya da 64-bit sistemler için  `go1.0.3.windows-amd64.msi` seçin. Sayfanın sonuna gidip "next" tıklayın, kurulum bitince  `c:/go/bin` $PATH değişkenine otomatik olarak eklenecektir. Bir terminal açıp  `go` yazın ve enter tuşuna basın. Şekil 1.1'dekine benzer bir çıktı almanız gerekiyor.

## Üçüncü parti yazılımları kullanarak

### GVM

GVM üçüncü parti çoklu Go versiyonlarını kullanmayı sağlayan bir yazılım, ruby için rvm gibi. Kullanımı oldukça basit. Aşağıdaki komutları terminalinize yazarak kurabilirsiniz:

    bash < <(curl -s -S -L https://raw.github.com/moovweb/gvm/master/binscripts/gvm-installer)

Sonrasında Go'yu kurmak için:

    gvm install go1.0.3
    gvm use go1.0.3

İşlemler bitince, hazırsınız.

### apt-get

Ubuntu en popüler Linux dağıtımlarından biridir. Ubuntu `apt-get` paket yöneticisini kullanıyor. Aşağıdaki komutlarla Go'yu rahatça kurabilirsiniz.

    sudo add-apt-repository ppa:gophers/go
    sudo apt-get update
    sudo apt-get install golang-stable

### Homebrew

Homebrew Mac işletim sistemi için yazılmış bir paket yönetim sistemidir. Go'yu kurmak için aşağıdaki komutu kullanabilirsiniz.

    brew install go

## Linkler

- [İçerik](preface.md)
- Önceki bölüm: [Go ortam yapılandırma](01.0.md)
- Sonraki bölüm: [$GOPATH ve çalışma ortamı](01.2.md)
