# Go geliştirme araçları

Bu bölümde, otomatik formatlama ve akıllı kod tamamlama gibi  özelliklerine sahip, daha hızlı ve verimle bir şekilde kodlama yapabileceğiniz IDE'lerden bahsedeceğim. Tüm IDE'ler cross-platform çalışabiliyor, aynı işletim sistemini kullanmıyor olasanız bile adımlar çok fazla değişiklik göstermeyecektir.  

## LiteIDE

LiteIDE, sadece go dili için destek veren visualfc tarafıdan geliştirilmiş açık kaynaklı ve hafif bir IDE.

![](images/1.4.liteide.png?raw=true)

Şekil 1.4 LiteIDE'nin ana ekranı

LiteIDE özellikleri:

- Cross-platform
	- Windows
	- Linux
	- Mac OS
- Çapraz derleme
	- Birden fazla ortam için derleme yapabilme
	- Go için çapraz derleme desteği
- Proje yönetim standartı
	- $GOPATH'e dayalı dökümantasyon görüntüleme
	- $GOPATH'e dayalı derleme sistemi
	- $GOPATH'e dayalı API dökümantasyonu
- Go kaynak kodu editörü
	- Code outlining
	- Gocode için tam destek
	- Go API dökümantasyonu desteği
	- `F1` kısayolu ile kod deyimini görme
	- `F2` fonksiyon tanımına gitme
	- Gdb desteği
	- `gofmt` ile oto-formatlama
- Diğer
	- Çoklu dil desteği
	- Eklenti sistemi
	- Metin editör temaları
	- Kate'e dayalı söz dizimi desteği
	- Kodlama esnasında tamamlama özelliği
	- Ayarlanabilir kısayollar
	- Markdown desteği
		- Anlık önizleme
		- özelleştirilmiş CSS
		- HTML ve PDF olarak çıktı alma
		- HTML ve PDF'e dönüştürme
		
### LiteIDE kurulumu

- LiteIDE kur
	- [Indirme Sayfası](http://code.google.com/p/golangide)
	- [Kaynak Kodu](https://github.com/visualfc/liteide)
	
	Önce Go'yu kurmanız gerekiyor, sonra işletim sisteminize uygun verisyonunu indirebilirsiniz. Arşivi istediğiniz dizine açıp kullabilirsiniz.
- gocode kur

	Akıllı tamamlama özelliği için gocode'u kurmanız gerekiyor:
	
		go get -u github.com/nsf/gocode
		
- Derleme Ortamı

	Ayarlamalarınızı işletim sisteminize uygun bir şekilde yapın.
	Go'nun 64-bitlik versiyonunu windowsta koşturuyorsanız, araç çubugunda konfigürasyon ortamı olarak  win64 olarak ayarlayın.`option` menüsü altındaki `liteEnv` sekmesine tıklayın ve `win64.env` adlı dosyayı açın.
	
		GOROOT=c:\go
		GOBIN=
		GOARCH=amd64
		GOOS=windows
		CGO_ENABLED=1

		PATH=%GOBIN%;%GOROOT%\bin;%PATH%
		。。。
	
	`GOROOT=c:\go` satırını kendi Go kurulu dizininize ayarlayın ve kaydedin. MinGW64 kullanıyorsanız,`c:\MinGW64\bin`yi `cgo` desteği için PATH değişkenine ekleyin.
	
	Go'nun 64-bitlik linuxta koşturuyorsanız, araç çubuğunda kanfigürasyon ortamı olarak linux64 olarak ayarlayın. `option` menüsü altındaki `liteEnv` sekmesine tıklayın ve `linux64.env` adlı dosyayı açın.
	
		GOROOT=$HOME/go
		GOBIN=
		GOARCH=amd64
		GOOS=linux
		CGO_ENABLED=1

		PATH=$GOBIN:$GOROOT/bin:$PATH   
		。。。
		
	`GOROOT=$HOME/go` kendi Go kurulu dizininize ayarlayın ve kaydedin. 
- $GOPATH
	$GOPATH, projelerin bulunuduğu dizini ifade ediyor. Komut istemcisini açın (ya da `Ctrl+` tuşuna basın), `go help gopath`  komutu ile daha ayrıntılı bilgi elde edebilirsiniz.
	$GOPATH'in içindekileri görüp, dizin yolunu değiştirmek LiteIDE kullanarak çok basit bir şekilde ayarlanabilir.`View - Setup GOPATH` size düzenleme yapabileceğiniz bir pencere açacaktır.
	
## Sublime Text

Sıradaki IDE'miz Sublime Text 2 (kısaca Sublime'de diyebilirsiniz) + GoSublime + gocode + MarGo.

- Akıllı tamamlama

	![](images/1.4.sublime1.png?raw=true)
	
	Şekil 1.5 Sublime akıllı tamamlama
- Kaynak dosyalarını oto-formatlama
- Proje yönetimi

	![](images/1.4.sublime2.png?raw=true)
	
	Şekil 1.6 Sublime proje yönetimi
	
- Söz dizimi renklendirme
- Fonksiyon kısıtlaması olmaksızın bedava sürüm. Arada bir lisans alma penceresi çıkabilir, ama kapatıp geçebilirsiniz. Eğer hoşunuza gider ve daha verimli kodlar yazmak isterseniz full sürümünü satın alın ve geliştiricilere destek olun!

İşletim sisteminize uygun [Sublime](http://www.sublimetext.com/) versiyonunu indirin.

1. Ctrl+`'ye basın ve aşağıdaki komutu girin.

		import urllib2,os; pf='Package Control.sublime-package'; ipp=sublime.installed_packages_path(); os.makedirs(ipp) if not os.path.exists(ipp) else None; urllib2.install_opener(urllib2.build_opener(urllib2.ProxyHandler())); open(os.path.join(ipp,pf),'wb').write(urllib2.urlopen('http://sublime.wbond.net/'+pf.replace(' ','%20')).read()); print 'Please restart Sublime Text to finish installation'
		
	Kurulum tamamlandıktans sonra Sublime yeniden başlatın. "Preferences" menüsünde "Package Control" sekmesine tıklayın.
	
	![](images/1.4.sublime3.png?raw=true)
	
	Şekil 1.7 Sublime Package Control
2. GoSublime, SidebarEnhancements ve Go Build kurmak için,  `Ctrl+Shift+p` tuşlarına basıp  Package Control penceresini açın,  `pcip` yazın ("Package Control: Install Package"nin kısaltması).

	![](images/1.4.sublime4.png?raw=true)
	
	Şekil 1.8 Sublime Paket kurulumu
	
	"GoSublime" yazın, OK tuşuna tıklayıp paketi yükleyin, aynı adımlarıSidebarEnhancements ve Go Build kurmak için tekrarlayın. Bir defa daha, kurulumlar bittikten sonra tekrar başlatın.
3. Kurulumun başarılı olup olmadığını öğrenmek için, Sublime ile bir go dosyasını açıp renklendirme yapıp yapmadığına bakabilirsiniz. `import` yazarak kod tamamlamanın çalışıp çalışmadığını anlayabilirsiniz. `import "fmt"` yazdıktan sonra, `fmt.` yazın ve `fmt` kütüphanesinin metodlarının listelendiğini görebilirsiniz.

	Herşey tamamsa, kurulum başarıyla tamamlanmıştır demektir.
	
	Eğer değilde terminali açıp `gocode` komutunu çalıştıramıyorsanız $PATH değişkeniniz doğru ayarlanmamış demektir.
	
## Vim

Vim, programcılar arasında çok populer bir araçtır, Vi'nin gelişmiş versiyonudur. Akıllı tamamlama, hata ayıklama ve derleme için fonksiyonları mevcut.

![](images/1.4.vim.png?raw=true)
	
Şekil 1.8 Vim Go için akıllı tamamlama

1. Go için renklendirme

		cp -r $GOROOT/misc/vim/* ~/.vim/
		
2. Renklendirme ayarını açmak için 

		filetype plugin indent on
		syntax on
		
3. [gocode](https://github.com/nsf/gocode/) kur

		go get -u github.com/nsf/gocode
		
	gocode öntanımlı olarak `$GOBIN` dizinine kurulacaktır

4. [gocode](https://github.com/nsf/gocode/) ayarla

		~ cd $GOPATH/src/github.com/nsf/gocode/vim
		~ ./update.bash
		~ gocode set propose-builtins true
		propose-builtins true
		~ gocode set lib-path "/home/border/gocode/pkg/linux_amd64"
		lib-path "/home/border/gocode/pkg/linux_amd64"
		~ gocode set
		propose-builtins true
		lib-path "/home/border/gocode/pkg/linux_amd64"

5. Tebrikler! Go'nun dünyasını keşfetmek için  `:e main.go` yazın!

## Emacs

Emacs ölümcül bir silah olarak bilinir. Sadece bir metin editörü değil, aynı zamanda çok güçlü bir IDE'dedir.

![](images/1.4.emacs.png?raw=true)

Şekil 1.10 Emacs Go editörü ana ekranı

1. Sözdizimi renklendirme
	
		cp $GOROOT/misc/emacs/* ~/.emacs.d/
		
2. [gocode](https://github.com/nsf/gocode/) kur

		go get -u github.com/nsf/gocode
		
	gocode öntanımlı olarak `$GOBIN` dizinine kurulacaktır
3. [gocode](https://github.com/nsf/gocode/) ayarla

		~ cd $GOPATH/src/github.com/nsf/gocode/vim
		~ ./update.bash
		~ gocode set propose-builtins true
		propose-builtins true
		~ gocode set lib-path "/home/border/gocode/pkg/linux_amd64"
		lib-path "/home/border/gocode/pkg/linux_amd64"
		~ gocode set
		propose-builtins true
		lib-path "/home/border/gocode/pkg/linux_amd64"
		
4. [Oto tamamlama](http://www.emacswiki.org/emacs/AutoComplete)'yı kur 
	İndirin ve arşivi açın
	
		~ make install DIR=$HOME/.emacs.d/auto-complete
	
	~/.emacs dosyasını ayarlayın
	
		;;auto-complete
		(require 'auto-complete-config)
		(add-to-list 'ac-dictionary-directories "~/.emacs.d/auto-complete/ac-dict")
		(ac-config-default)
		(local-set-key (kbd "M-/") 'semantic-complete-analyze-inline)
		(local-set-key "." 'semantic-complete-self-insert)
		(local-set-key ">" 'semantic-complete-self-insert)	
		
	Bu  [adresten](http://www.emacswiki.org/emacs/AutoComplete) daha fazla bilgi edinebilirsiniz.
5. .emacs ayarlayın

		;; golang mode
		(require 'go-mode-load)
		(require 'go-autocomplete)
		;; speedbar
		;; (speedbar 1)
		(speedbar-add-supported-extension ".go")
		(add-hook
		'go-mode-hook
		'(lambda ()
    		;; gocode
    		(auto-complete-mode 1)
    		(setq ac-sources '(ac-source-go))
    		;; Imenu & Speedbar
    		(setq imenu-generic-expression
        		'(("type" "^type *\\([^ \t\n\r\f]*\\)" 1)
        		("func" "^func *\\(.*\\) {" 1)))
    		(imenu-add-to-menubar "Index")
    		;; Outline mode
    		(make-local-variable 'outline-regexp)
    		(setq outline-regexp "//\\.\\|//[^\r\n\f][^\r\n\f]\\|pack\\|func\\|impo\\|cons\\|var.\\|type\\|\t\t*....")
    		(outline-minor-mode 1)
    		(local-set-key "\M-a" 'outline-previous-visible-heading)
    		(local-set-key "\M-e" 'outline-next-visible-heading)
    		;; Menu bar
    		(require 'easymenu)
    		(defconst go-hooked-menu
        		'("Go tools"
        		["Go run buffer" go t]
        		["Go reformat buffer" go-fmt-buffer t]
        		["Go check buffer" go-fix-buffer t]))
    		(easy-menu-define
        		go-added-menu
        		(current-local-map)
        		"Go tools"
        		go-hooked-menu)

    		;; Other
    		(setq show-trailing-whitespace t)
    		))
		;; helper function
		(defun go ()
    		"run current buffer"
    		(interactive)
    		(compile (concat "go run " (buffer-file-name))))

		;; helper function
		(defun go-fmt-buffer ()
    		"run gofmt on current buffer"
    		(interactive)
    		(if buffer-read-only
    		(progn
        		(ding)
        		(message "Buffer is read only"))
    		(let ((p (line-number-at-pos))
    		(filename (buffer-file-name))
    		(old-max-mini-window-height max-mini-window-height))
        		(show-all)
        		(if (get-buffer "*Go Reformat Errors*")
    		(progn
        		(delete-windows-on "*Go Reformat Errors*")
        		(kill-buffer "*Go Reformat Errors*")))
        		(setq max-mini-window-height 1)
        		(if (= 0 (shell-command-on-region (point-min) (point-max) "gofmt" "*Go Reformat Output*" nil "*Go Reformat Errors*" t))
    		(progn
        		(erase-buffer)
        		(insert-buffer-substring "*Go Reformat Output*")
        		(goto-char (point-min))
        		(forward-line (1- p)))
    		(with-current-buffer "*Go Reformat Errors*"
    		(progn
        		(goto-char (point-min))
        		(while (re-search-forward "<standard input>" nil t)
        		(replace-match filename))
        		(goto-char (point-min))
        		(compilation-mode))))
        		(setq max-mini-window-height old-max-mini-window-height)
        		(delete-windows-on "*Go Reformat Output*")
        		(kill-buffer "*Go Reformat Output*"))))
		;; helper function
		(defun go-fix-buffer ()
    		"run gofix on current buffer"
    		(interactive)
    		(show-all)
    		(shell-command-on-region (point-min) (point-max) "go tool fix -diff"))
6. Tebrikler, kurulumu tamamladınız! Speedbar öntanımlı olarak kapalı gelir, `;;(speedbar 1)` önündeki yorum satırını kaldırın, ya da `M-x speedbar` şeklinde kullanabilirsiniz.

## Eclipse

Eclipse'de çok tutulan geliştirme araçlarındandır. Size Eclipse ile nasıl Go programları yazabileceğinizi göstereceğim.

![](images/1.4.eclipse1.png?raw=true)

Şekil 1.1 Eclipse Go editörü ana ekran

1. [Eclipse](http://www.eclipse.org/) indirip kurun
2. [goclipse](https://code.google.com/p/goclipse/) indirin
	[http://code.google.com/p/goclipse/wiki/InstallationInstructions](http://code.google.com/p/goclipse/wiki/InstallationInstructions)
3. gocode indirin

	Github'dan gocode.
	
		https://github.com/nsf/gocode
		
	Windows için git kurmalısınız, genelde biz [msysgit](https://code.google.com/p/msysgit/) kullanıyoruz
	
	gocode kurun 
	
		go get -u github.com/nsf/gocode
		
	Eğer isterseniz kaynak kodu derleyerek kendinizde kurabilirsiniz.
4. [MinGW](http://sourceforge.net/projects/mingw/files/MinGW/) indirip kurun
5. Ekenlentileri ayarlayın.

	Windows->Preferences->Go
	
	(1).Go derleyicisini ayarlayın
	
	![](images/1.4.eclipse2.png?raw=true)
	
	Şekil 1.12 Eclipse için Go ayarlamaları
	
	(2).gocode ayarlayın, gocode'u  gocode.exe'nin olduğu dizine ayarlayın.
	
	![](images/1.4.eclipse3.png?raw=true)
	
	Şekil 1.13 gocode Ayarları
	
	(3). gdb ayarları , gdb'yi gdb.exe'nin olduğu dizine ayarlayın.
	
	![](images/1.4.eclipse4.png?raw=true)
	
	Şekil 1.14 gdb Ayarları
6. Kurulumu kontrol edin

	Yeni bir Go projesi oluşturun ve hello.go adında bir dosya açın.
	
	![](images/1.4.eclipse5.png?raw=true)
	
	Şekil 1.15 Yeni bir proje ve dosya
	
	Aşağıdaki gibi test edin.(Eclipse'in terminalinde komutuları çalıştırmanız gerekiyor)
	
	![](images/1.4.eclipse6.png?raw=true)
	
	Şekil 1.16 Eclipse'de Go'yu test etme

## IntelliJ IDEA

Daha önce java ile uğraşanlar IntelliJ'yi biliyordur. Bir eklenti sayesinde Go IDE'si haline gelebiliyor.

1. IDEA idirin, Ultimate ve Community versiyonları arasında pek bir fark yok.

	![](images/1.4.idea1.png?raw=true)
	
2. Go eklentisini kurun. `File - Setting - Plugins` yolunu izleyin,  sonra  `Browser repo`'ya tıklayın.

	![](images/1.4.idea3.png?raw=true)
	
3. `golang`'ı aratın, `download and install`'a çift tıklatın ve indirme işleminin bitmesini bekleyin.

	![](images/1.4.idea4.png?raw=true)
	
	`Apply` tıklayıp, sonra yeniden başlatın.
4. Yeni bir Go projesi oluşturun

	![](images/1.4.idea5.png?raw=true)
	
	Bir sonraki adımda Go'nun kurulu olduğu dizini verin -yani $GOROOT dizinini.
	
( ***Bu a [blog yazısında](http://wuwen.org/tips-about-using-intellij-idea-and-go/) daha ayrıntlı bilgiler bulabilirsiniz *** )

## Linkler

- [İçerik](preface.md)
- Önceki bölüm: [Go komutları](01.3.md)
- Sonraki bölüm: [Özet](01.5.md)
