# 1.1 Installation

## 3 méthodes d'installation

Il y a plusieurs façons de configurer votre environnement de développement Go sur votre ordinateur,
vous pouvez choisir celle qui vous convient le mieux. Les trois façons les plus courantes sont les suivantes.

- Paquets d'installation officiels:
	- L'équipe de Go propose des paquets d'installation pour Windows, Linux, Mac et encore d'autres systèmes d'exploitation.
  C'est propablement la méthode la plus simple pour commencer.
- Installation manuelle via les sources
    -  Populaire chez les développeurs habitués aux environnements type Unix.
- Utilisation d'outils tiers.
	- Il y a plusieurs outils tiers et gestionnaires pour installer Go, comme apt-get pour Ubuntu et homebrew pour Mac.
	
Dans le cas où vous voudriez installer plus d'une version de Go sur votre machine, vous devriez jeter un oeil à l'outil [GVM](https://github.com/moovweb/gvm).
C'est le meilleur outil pour accomplir cette tâche, sinon vous devrez le faire vous-même.

##Installation à partir des sources 

Parce-que certaines parties de Go sont écrits en C Plan 9 et en assembleur AT&T, vous devez installer un compilateur C avant de continuer.

Sous Mac, si vous avez Xcode d'installé, vous disposé déjà d'un compilateur.

Sur un système type Unix, vous devez installer gcc ou un compilateur équivalent. Par exemple, en utilisant le gestionnaire de paquets apt-get(livré avec Ubuntu),
vous pouvez installer les compilateurs requis comme suit:

 `sudo apt-get install gcc libc6-dev`

Sous Windows, vous devez installer MinGW pour installer gcc. N'oubliez pas de configurer vos varaibles d'environnement après avoir finalisé l'installation.

L'équipe Go utilise [Mercurial](http://mercurial.selenic.com/downloads/) pour gérer le code source, vous devez commencer par installer celui-ci pour
télécharger le code source de Go.

Une fois Mercurial installé, exécutez les commandes suivantes pour cloner le code source de Go et le compiler:

	hg clone -u release https://code.google.com/p/go
	cd go/src
	./all.bash
	
Une installation réussie finira en affichant le message "ALL TESTS PASSED."

Sous Windows, vous pouvez arriver à faire la même chose en lançant `all.bat`.

Si vous utilisez Windows, le paquet d'installation va mettre à jour automatiquement vos variables d'environnement.
Sous Unix, vous devez configurer celles-ci manuellement comme suit:

    export GOROOT=$HOME/go
    export GOBIN=$GOROOT/bin
    export PATH=$PATH:$GOROOT/bin

Si vous voyez l'affichage suivant sur votre écran, l'installation s'est terminée avec succès.

![](images/1.1.mac.png?raw=true)

Figure 1.1 Information après installation

Lorsque vous voyez les informations d'utilisation de Go, cela signifie que vous avez installé Go avec succès sur votre ordinateur.
Si votre système affiche 'aucune commande Go', vérifiez que votre variable d'environnement $PATH contient bien le chemin d'installation de Go.

## Utilisation des paquets standards d'installation

Go a des paquets d'installation rapides pour chaque système d'exploitation supporté.
Ces paquets installent Go dans `/usr/local/go` (`c:\Go` sous Windows) par défaut. Bien sûr, cela est configurable, mais vous aurez également à changer manuellement
les variables d'environnement comme décrit précédemment.

### Comme savoir si votre système est 32 ou 64 bits?

L'étape suivante dépend du type d'architecture de votre système, nous devons donc le vérifier avant de télécharger les paquets d'installation.

Si vous utilisez Windows , tapez `Win+R` et lancez l'outil de commandes `cmd`.
Lancez la commande `systeminfo` qui va vous afficher des informations très utiles sur votre système.
Trouvez la ligne indiquant "type du système" - si vous voyez "x64-based PC" cela signifie que votre système est 64-bit, sinon il est 32-bit.

Je vous recommande fortement de télécharger le paquet 64-bit si vous êtes sous Mac, comme Go ne supporte plus les processeurs 32-bit sous Mac OSX.

Les utilisateurs Linux peuvent exécuter `uname -a` dans un terminal pour afficher les informations système.
Un système d'exploitation 64-bit affichera les informations suivantes:

    <descriptions diverses> x86_64 x86_64 x86_64 GNU/Linux

Certaines machines comme Ubuntu 10.04 afficheront simplement:

    x86_64 GNU/Linux

Les systèmes 32-bit afficheront quant à eux:

    <descriptions diverses> i686 i686 i386 GNU/Linux

### Mac

Aller sur la [page de téléchargement][downlink], choisir `go1.4.darwin-386.pkg` pour le systèmes 32-bit
et `go1.4.darwin-amd64.pkg` pour les 64-bit. Cliquez "next" jusqu'à la fin du processus, `~/go/bin` sera ajouté au $PATH du système à la fin de l'installation.
Maintenant ouvrez un terminal et tapez `go`. Vous devriez avoir la même sortie qu'en figure 1.1.

### Linux

Aller à la [page de téléchargement][downlink], choisir `go1.4.linux-386.tar.gz` pour les systèmes 32-bit et
`go1.4.linux-amd64.tar.gz` en 64-bit. Supposons que vous voulez installer Go dans `$GO_INSTALL_DIR` path. 
Décompressez l'archive `tar.gz` dans le dossier désiré de destination en utilisant la commande `tar zxvf go1.4.linux-amd64.tar.gz -C $GO_INSTALL_DIR`.
Ensuite définissez votre $PATH avec: `export PATH=$PATH:$GO_INSTALL_DIR/go/bin`.
Vous pouvez maintenant ouvrir un terminal et tapez `go`. Vous devriez avoir la même sortie qu'en figure 1.1.

### Windows

Allez à la [page de téléchargement][downlink], choisissez `go1.4.windows-386.msi` pour les systèmes 32-bit et
`go1.4.windows-amd64.msi` pour le ssystèmes 64-bit. Cliquez "next" jusqu'à la fin du processus, `c:/go/bin` sera ajhouté à `path`.
Vous pouvez maintenant ouvrir un terminal et tapez `go`. Vous devriez avoir la même sortie qu'en figure 1.1. 

## Utilisez des outils tiers

### GVM

GVM est un outil de gestion de versions multiples développé par un tiers, comme rvm pour ruby.
Il est simple d'utilisation. Installez GVM avec les commandes suivantes dans votre terminal:

    bash < <(curl -s -S -L https://raw.github.com/moovweb/gvm/master/binscripts/gvm-installer)

Ensuite nous installons Go avec les commandes suivantes:

    gvm install go1.4
    gvm use go1.4

À la fin du processus, Go est installé.

### apt-get

Ubuntu est la version bureau la plus utilisée de Linux. Elle utilise `apt-get` comme gestionnaire de paquets.
On peut installer Go avec les commandes suivantes:

    sudo add-apt-repository ppa:gophers/go
    sudo apt-get update
    sudo apt-get install golang-stable

### Homebrew

Homebrew est un outil de gestion de logiciels communément utilisé sous Mac pour gérer les paquets.
On peut installer Go avec les commandes suivantes:

    brew install go

## Navigation

- [Tables des matières](preface.md)
- Section précédente: [Configuration de votre environnement Go](01.0.md)
- Section suivante: [$GOPATH et workspace](01.2.md)

[downlink]: http://golang.org/dl/ "Téléchargement de Go"
